package com.hdkj.lt.core.sys.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hdkj.lt.core.sys.model.dto.OrgInfoDto;
import com.hdkj.lt.core.sys.model.dto.UnitQueryDTO;
import com.hdkj.lt.core.sys.model.po.SysStru;
import com.hdkj.lt.core.sys.model.po.OrganizationBo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @Description:
 * @Author: wenhao
 * @Create: 2023/12/07 17:10
 * @Version: 1.0
 */
@Mapper
public interface SysStruMapper extends BaseMapper<SysStru> {

    /**
     * 获取机构信息
     */
    List<OrgInfoDto> listByCondition(@Param("params") UnitQueryDTO queryDTO);

    List<OrgInfoDto> getCityByPsrId(@Param("psrId")String psrId);

    List<OrgInfoDto> getCountyByPsrId(@Param("psrId")String psrId);
    /**
     * 根据机构类型获取用户节点
     */
    Integer getUserNodeByOrgType(@Param("unitCode") Long unitCode, @Param("userNode") Integer userNode);

    /**
     * 获取省公司下的所有机构信息
     */
    List<SysStru> queryProvinceStruList();

    /**
     * 获取组织机构详情
     */
    List<OrganizationBo> selectOrganByIds(@Param("parentId") Long parentId);

    /**
     * 获取下级班组机构信息
     */
    List<Long> getTeamChildrenStru(Long struId);

    /**
     * 根据组织机构编码查询单条信息（省，地市，区县）
     */
    SysStru getStruById(@Param("struId") Long struId);


    /**
     * 根据组织机构编码查询下一级组织机构集合，（地市，区县）
     */
    List<SysStru> getStruByParentIds(@Param("struIdList") List<Long> struIdList);

    /**
     * 根据组织机构编码查询上一级组织机构
     */
    SysStru getStruByChildId(@Param("struId") Long struId);

    /**
     *  查询省，市，区县信息
     */
    List<SysStru> getStruList();

}
